

#include <X11/X.h>
#include <X11/extensions/Print.h>


main() {

 Display *pdpy; /* Display pointer fuer Drucker */
 XPPrinterList plist; /* Liste verfuegbarer Drucker */
 int pcount; /* Anzahl verfuegbarer Drucker */
 XPContext pcontext; /* "print context" */
 Screen *pscreen;
 Window pwin;
 GC pgc;
 XEvent ev;
 char *attribute;
 unsigned short pwidth, pheight;
 unsigned int swidth, sheight;
 int xhot, yhot;
 XRectangle area;
 Font pfont;
 static char jobname[100], *pname;
 XColor color;
 Pixmap stipple;

 register int i;
 
 pdpy = XOpenDisplay(":1.0");

 pfont = XLoadFont(pdpy,
 "-*-helvetica-medium-r-normal--*-420-75-75-p-*-iso8859-1");

 plist = XpGetPrinterList(pdpy, NULL, &pcount);
 
 i = 0;
 while (i < pcount) {
 printf("Drucker %s: %s\n", plist[i].name, plist[i].desc);
 if (strncmp(plist[i].name,"File",4) == 0) {
 pcontext = XpCreateContext(pdpy,plist[i].name);
	pname = strdup(plist[i].name);
 }
 i++;
 }
 XpFreePrinterList(plist);
 XpSetContext(pdpy,pcontext);
 /*
 * Wir wollen alle PrintNotify-Events bekommen
 */
 XpSelectInput(pdpy, pcontext, XPPrintMask);
 sprintf(jobname,"%s.job-name: ck%1d",pname,getpid());
 XpSetAttributes(pdpy,pcontext, XPJobAttr, jobname, XPAttrMerge);
 /*
 * Hier muesste man wahrscheinlich auf
 * einen XPAttributeNotify-Event warten ;-)
 */
 XpStartJob(pdpy, XPSpool);
 pscreen = XpGetScreenOfContext(pdpy, pcontext);
 /*
 * Bsp. fuer Attribute-Abfrage: 
 * Jobname der gerade gesetzt wurde
 */
 attribute = XpGetOneAttribute(pdpy, pcontext, 
				XPJobAttr, 
				"job-name");
 printf("Job name: %s\n",attribute);
 XFree(attribute);

 XpGetPageDimensions(pdpy, pcontext, &pwidth, &pheight, &area);

 pwin = XCreateSimpleWindow(pdpy, DefaultRootWindow(pdpy), area.x, area.y, 
			 area.width, area.height,
			 0, 1, WhitePixelOfScreen(pscreen));
 XpStartPage(pdpy, pwin);
 pgc = XCreateGC(pdpy, pwin, NULL, 0);
 XSetForeground(pdpy, pgc, BlackPixelOfScreen(pscreen));
 XSetFont(pdpy, pgc, pfont);
 /*
 * "Rechteck" malen
 */
 XDrawRectangle(pdpy, pwin, pgc, 0, 0, 300, 300);
 /*
 * Diagonale Linie und "Hallo" malen
 */
 XDrawLine(pdpy, pwin, pgc, 0,0, 300, 300);
 XDrawString(pdpy, pwin, pgc, 150, 420, "Hallo", 5);

 /*
 * Rechteck erst gruen und dann mit durchscheinendem
 * Muster (horizontale Linien) fuellen
 */
 XParseColor(pdpy, DefaultColormapOfScreen(pscreen),"light green",&color);
 XAllocColor(pdpy, DefaultColormapOfScreen(pscreen),&color);
 XSetForeground(pdpy, pgc, color.pixel);
 XFillRectangle(pdpy, pwin, pgc, 350, 0,300,300);
 XSetForeground(pdpy, pgc, BlackPixelOfScreen(pscreen));
 XSetFillStyle(pdpy, pgc, FillStippled);
 XReadBitmapFile(pdpy, pwin, "/usr/X11R6/include/X11/bitmaps/hlines3",
		 &swidth, &sheight, &stipple, &xhot, &yhot);
 XSetStipple(pdpy, pgc, stipple);
 XFillRectangle(pdpy, pwin, pgc, 350,0,300,300);
 /*
 * Seite schliessen, Job schliessen, hoffentlich drucken
 */
 XpEndPage(pdpy);
 XpEndJob (pdpy);
 /*
 * Warten bis der Druckerserver fertig ist
 */
 do {
 XNextEvent(pdpy,&ev);
 }
 while (ev.type != XPPrintNotify && 
	 ((XPPrintEvent *)(&ev))->detail != XPEndJobNotify) ;
end:
 XpDestroyContext(pdpy, pcontext);
 XCloseDisplay(pdpy);
}
